=== docs/CMakeLists.txt ===
ADD_SUBDIRECTORY(coding_style)
ADD_SUBDIRECTORY(doxygen)
ADD_SUBDIRECTORY(epydoc)
ADD_SUBDIRECTORY(wiki)
