=== k3dsdk/gl/CMakeLists.txt ===
FILE(GLOB HEADERS *.h)
FILE(GLOB SOURCES *.cpp)

LIST(SORT HEADERS)
LIST(SORT SOURCES)

K3D_ADD_LIBRARY(k3dsdk-opengl SHARED ${HEADERS} ${SOURCES})
K3D_GENERATE_DEF_FILE(K3dsdk-opengl)
TARGET_LINK_LIBRARIES(k3dsdk-opengl
	k3dsdk
	)

INSTALL(TARGETS k3dsdk-opengl
	RUNTIME DESTINATION bin 
	LIBRARY DESTINATION ${K3D_LIBDIR}
	ARCHIVE DESTINATION ${K3D_LIBDIR})
