=== debian/changelog ===
k3d (0.8.0.5-1) unstable; urgency=low

  * New upstream release
  * Drop patches for fixes now handled upstream:
    - fix-ftbfs.patch

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 18 Nov 2015 14:24:43 +0000

k3d (0.8.0.4-1) unstable; urgency=low

  * New upstream release
  * Drop patches backported from upstream:
    - fix-ftbfs-boost-1.58.patch
    - 34066a41baa5d1e8b7c4288e678b2894a5013466.patch
  * d/rules: add -std=c++11, needed by newer sigc++ and glibmm
  * d/patches:
    - Add fix-ftbfs.patch, to fix a minor recent compilation problem
      (conversion of boost::shared_ptr to bool in return)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sun, 01 Nov 2015 01:05:02 +0000

k3d (0.8.0.3-8) unstable; urgency=medium

  * debian/control: Sort items in build-depends
  * Patches to fix FTBFS with boost-1.58 (Closes: #795814)
    - fix-ftbfs-boost-1.58.patch, header file from Boost Math moved away,
      see upstream release notes of version 1.56
    - 34066a41baa5d1e8b7c4288e678b2894a5013466.patch, ported from upstream
      to fix another problem with Boost version 1.56

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 23 Sep 2015 22:44:39 +0100

k3d (0.8.0.3-7) unstable; urgency=medium

  * Bump Standards-Version to 3.9.6 (no changes needed)
  * Fix lintian error: "build-depends: python-support => use dh_python2
    instead"

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Mon, 29 Sep 2014 23:05:45 +0100

k3d (0.8.0.3-6) unstable; urgency=medium

  * Move everything from Build-Depends-Indep back to Build-Depends
    (remaining: doxygen, graphviz, librsvg2-bin), since it continues
    failing to build in buildds (uses commands or files provided by these
    packages, apparently unconditionally, and without declaring them).

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sun, 02 Mar 2014 10:28:52 +0000

k3d (0.8.0.3-5) unstable; urgency=medium

  * Move asciidoc, docbook-xml, docbook-xsl and xsltproc from
    Build-Depends-Indep to Build-Depends, otherwise it fails to build in
    buildds and there is no easy way to disable/disentangle

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sun, 02 Mar 2014 01:33:51 +0000

k3d (0.8.0.3-4) unstable; urgency=medium

  * Bump Standards-Version to 3.9.5 (no changes needed)
  * Changes in Build-Depends:
    - Remove libsuperlu3-dev, not directly used now (Closes: #740428)
    - Remove librsvg2-dev (only -bin seems to be necessary, now in Indep)
    - Build-Depends-Indep to try to speed up builds, specially in less
      powerful machines: asciidoc, docbook-xml, docbook-xsl, doxygen
      (added), graphviz, librsvg2-bin (added, only -dev before), xsltproc
  * Move manpage to k3d-data package

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sat, 01 Mar 2014 19:42:02 +0000
