=== debian/control ===
Source: k3d
Section: graphics
Priority: extra
Standards-Version: 3.9.6
Maintainer: Manuel A. Fernandez Montecelo <mafm@debian.org>
Homepage: http://www.k-3d.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/k3d.git
Vcs-Git: git://anonscm.debian.org/collab-maint/k3d.git
Build-Depends: debhelper (>= 9~),
               asciidoc,
               cmake (>> 2.6),
               dh-python,
               docbook-xml,
               docbook-xsl,
               doxygen,
               gettext,
               graphviz,
               lib3ds-dev,
               libboost-date-time-dev (>= 1.42),
               libboost-dev (>= 1.42),
               libboost-program-options-dev (>= 1.42),
               libboost-python-dev (>= 1.42),
               libboost-regex-dev (>= 1.42),
               libboost-test-dev (>= 1.42),
               libcairomm-1.0-dev,
               libcgal-dev (>= 4.0) [!armel],
               libdbus-glib-1-dev,
               libfreetype6-dev,
               libftgl-dev,
               libgl1-mesa-dev | libgl-dev,
               libglew-dev,
               libglewmx-dev,
               libglibmm-2.4-dev,
               libglu1-mesa-dev | libglu-dev,
               libgnomevfs2-dev,
               libgraphviz-dev,
               libgtkglext1-dev,
               libgtkmm-2.4-dev,
               libgtksourceview2.0-dev,
               libgts-dev,
               libjpeg-dev,
               libmagick++-dev,
               libode-dev,
               libopenexr-dev,
               libpng-dev,
               librsvg2-bin,
               libsigc++-2.0-dev,
               libtiff-dev,
               libxml2-dev | libexpat1-dev,
               pkg-config,
               python-dev,
               uuid-dev,
               xsltproc,
               zlib1g-dev


Package: k3d
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         k3d-data (= ${source:Version})
Replaces: k3d-dev (<< 0.8.0.1)
Breaks: k3d-dev (<< 0.8.0.1)
Description: 3D modeling and animation system, binary files
 K-3D is free-as-in-freedom 3D modeling and animation software. It combines
 flexible plugins with a visualization pipeline architecture, making K-3D a
 versatile and powerful tool for artists.
 .
 This package contains binaries and libraries.

Package: k3d-data
Architecture: all
Replaces: k3d (<< 0.8.0.2-2)
Breaks: k3d (<< 0.8.0.2-2)
Depends: ${misc:Depends},
         ttf-bitstream-vera (>= 1.10)
Description: 3D modeling and animation system, data files
 K-3D is free-as-in-freedom 3D modeling and animation software. It combines
 flexible plugins with a visualization pipeline architecture, making K-3D a
 versatile and powerful tool for artists.
 .
 This package contains data needed by the binaries (shaders, GUI elements, ...).
